(ns clojure-demo.helpers
  (:require
   [cljs.core.async :refer [go]]
   [cljs.core.async.interop :refer [<p!]]
   [clojure.string :as str]
   [clojure-demo.state :refer [site-state]]))

(defn slugify [s]
  (when s
    (str
     (-> s
         (str/lower-case)
         (str/replace #"[^\w]+" "-")
         (str/replace #"^-\\|-\\-$" "")))))

(defn build-page-path [title]
  (str "http://127.0.0.1:8080/" #_"https://clojure-demos.digitaloctave.com/" "page/"
       (when (-> @site-state :current-route :parameters :path :page)
         (-> @site-state :current-route :parameters :path :page))
       "#" title)
  )


(defn copy->clipboard
  "Simple wrapper which copies text to the clipboard and resolves the promise"
  [text]
  (go (<p! (.writeText (.-clipboard js/navigator) (build-page-path text))) 
      (swap! site-state assoc :notification "Copied to clipboard")
      (prn "copied")))




(comment
  (.-writeText (.-clipboard js/navigator) "test")
  (copy->clipboard "test2"))
